PROJ = chanco
PROJFILE = chanco.mak
DEBUG = 0

PWBRMAKE  = pwbrmake
NMAKEBSC1  = set
NMAKEBSC2  = nmake
CC  = cl
CFLAGS_G  = /AC /W4 /G2 /Zp /BATCH /B2 C2L
CFLAGS_D  = /qc /Gi$(PROJ).mdt /Zr /Zi /Od
CFLAGS_R  = /Od /Gs
MAPFILE_D  = NUL
MAPFILE_R  = $(PROJ).map
LFLAGS_G  =  /NOI /STACK:12000  /BATCH
LFLAGS_D  = /CO /INC /FAR /PACKC /PACKD /PMTYPE:VIO
LFLAGS_R  =  /M /EXE /FAR /PACKC /PACKD  /PMTYPE:VIO
LINKER  = link
ILINK  = ilink
LRF  = echo > NUL
LLIBS_R  =  /NOD:CLIBCE CLIBCEP
LLIBS_D  =  /NOD:CLIBCE CLIBCEP

DEF_FILE  = chanco.def
OBJS  = chanco.obj config.obj exit.obj ..\lib\lprintf.obj ..\lib\readcfg.obj\
        ..\lib\getopt.obj ..\lib\finedir.obj ..\lib\active.obj\
        ..\lib\xopen.obj cancel.obj ..\lib\history.obj newgroup.obj\
        ..\lib\dbm.obj ..\lib\idx.obj rmgroup.obj ckgroups.obj\
        ..\lib\fcopy.obj ..\lib\mktemp.obj ..\lib\datetime.obj\
        ..\lib\version.obj
SBRS  = chanco.sbr config.sbr exit.sbr ..\lib\lprintf.sbr ..\lib\readcfg.sbr\
        ..\lib\getopt.sbr ..\lib\finedir.sbr ..\lib\active.sbr\
        ..\lib\xopen.sbr cancel.sbr ..\lib\history.sbr newgroup.sbr\
        ..\lib\dbm.sbr ..\lib\idx.sbr rmgroup.sbr ckgroups.sbr\
        ..\lib\fcopy.sbr ..\lib\mktemp.sbr ..\lib\datetime.sbr\
        ..\lib\version.sbr

all: $(PROJ).exe

.SUFFIXES:
.SUFFIXES: .obj .sbr .c

chanco.obj : chanco.c config.h chanco.h

chanco.sbr : chanco.c config.h chanco.h

config.obj : config.c config.h

config.sbr : config.c config.h

exit.obj : exit.c config.h

exit.sbr : exit.c config.h

..\lib\lprintf.obj : ..\lib\lprintf.c

..\lib\lprintf.sbr : ..\lib\lprintf.c

..\lib\readcfg.obj : ..\lib\readcfg.c

..\lib\readcfg.sbr : ..\lib\readcfg.c

..\lib\getopt.obj : ..\lib\getopt.c

..\lib\getopt.sbr : ..\lib\getopt.c

..\lib\finedir.obj : ..\lib\finedir.c

..\lib\finedir.sbr : ..\lib\finedir.c

..\lib\active.obj : ..\lib\active.c

..\lib\active.sbr : ..\lib\active.c

..\lib\xopen.obj : ..\lib\xopen.c

..\lib\xopen.sbr : ..\lib\xopen.c

cancel.obj : cancel.c config.h chanco.h

cancel.sbr : cancel.c config.h chanco.h

..\lib\history.obj : ..\lib\history.c

..\lib\history.sbr : ..\lib\history.c

newgroup.obj : newgroup.c config.h chanco.h

newgroup.sbr : newgroup.c config.h chanco.h

..\lib\dbm.obj : ..\lib\dbm.c

..\lib\dbm.sbr : ..\lib\dbm.c

..\lib\idx.obj : ..\lib\idx.c

..\lib\idx.sbr : ..\lib\idx.c

rmgroup.obj : rmgroup.c config.h chanco.h

rmgroup.sbr : rmgroup.c config.h chanco.h

ckgroups.obj : ckgroups.c config.h chanco.h

ckgroups.sbr : ckgroups.c config.h chanco.h

..\lib\fcopy.obj : ..\lib\fcopy.c

..\lib\fcopy.sbr : ..\lib\fcopy.c

..\lib\mktemp.obj : ..\lib\mktemp.c

..\lib\mktemp.sbr : ..\lib\mktemp.c

..\lib\datetime.obj : ..\lib\datetime.c

..\lib\datetime.sbr : ..\lib\datetime.c

..\lib\version.obj : ..\lib\version.c

..\lib\version.sbr : ..\lib\version.c


$(PROJ).bsc : $(SBRS)
        $(PWBRMAKE) @<<
$(BRFLAGS) $(SBRS)
<<

$(PROJ).exe : $(DEF_FILE) $(OBJS)
!IF $(DEBUG)
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
!IF $(DEBUG)
        $(ILINK) -a -e "$(LINKER) @$(PROJ).lrf" $@
!ELSE
        $(LINKER) @$(PROJ).lrf
!ENDIF


.c.obj :
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Fo$@ $<
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Fo$@ $<
!ENDIF

.c.sbr :
!IF $(DEBUG)
        $(CC) /Zs $(CFLAGS_G) $(CFLAGS_D) /FR$@ $<
!ELSE
        $(CC) /Zs $(CFLAGS_G) $(CFLAGS_R) /FR$@ $<
!ENDIF


run: $(PROJ).exe
        $(PROJ).exe $(RUNFLAGS)

debug: $(PROJ).exe
        CVP $(CVFLAGS) $(PROJ).exe $(RUNFLAGS)
