PROJ = expire
PROJFILE = expire.mak
DEBUG = 0

PWBRMAKE  = pwbrmake
NMAKEBSC1  = set
NMAKEBSC2  = nmake
CC  = cl
CFLAGS_G  = /AC /W4 /G2 /Zp /BATCH /B2 C2L
CFLAGS_D  = /qc /Gi$(PROJ).mdt /Zr /Zi /Od
CFLAGS_R  = /Od /Gs
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_G  =  /NOI /STACK:8192  /BATCH
LFLAGS_D  = /CO /INC /FAR /PACKC /PACKD /PMTYPE:VIO
LFLAGS_R  = /EXE /FAR /PACKC /PACKD /PMTYPE:VIO
LINKER  = link
ILINK  = ilink
LRF  = echo > NUL
LLIBS_R  =  /NOD:CLIBCE CLIBCEP
LLIBS_D  =  /NOD:CLIBCE CLIBCEP

DEF_FILE  = expire.def
OBJS  = expire.obj ..\lib\lprintf.obj ..\lib\getopt.obj ..\lib\readcfg.obj\
        config.obj ..\lib\finedir.obj ..\lib\xopen.obj ..\lib\dbm.obj\
        ..\lib\idx.obj exit.obj ..\lib\scandir.obj updactiv.obj arpatime.obj\
        misc.obj purgebya.obj purgebyh.obj ..\lib\datetime.obj match.obj\
        ..\lib\version.obj
SBRS  = expire.sbr ..\lib\lprintf.sbr ..\lib\getopt.sbr ..\lib\readcfg.sbr\
        config.sbr ..\lib\finedir.sbr ..\lib\xopen.sbr ..\lib\dbm.sbr\
        ..\lib\idx.sbr exit.sbr ..\lib\scandir.sbr updactiv.sbr arpatime.sbr\
        misc.sbr purgebya.sbr purgebyh.sbr ..\lib\datetime.sbr match.sbr\
        ..\lib\version.sbr

all: $(PROJ).exe

.SUFFIXES:
.SUFFIXES: .sbr .obj .c

expire.obj : expire.c config.h expire.h

expire.sbr : expire.c config.h expire.h

..\lib\lprintf.obj : ..\lib\lprintf.c

..\lib\lprintf.sbr : ..\lib\lprintf.c

..\lib\getopt.obj : ..\lib\getopt.c

..\lib\getopt.sbr : ..\lib\getopt.c

..\lib\readcfg.obj : ..\lib\readcfg.c

..\lib\readcfg.sbr : ..\lib\readcfg.c

config.obj : config.c config.h

config.sbr : config.c config.h

..\lib\finedir.obj : ..\lib\finedir.c

..\lib\finedir.sbr : ..\lib\finedir.c

..\lib\xopen.obj : ..\lib\xopen.c

..\lib\xopen.sbr : ..\lib\xopen.c

..\lib\dbm.obj : ..\lib\dbm.c

..\lib\dbm.sbr : ..\lib\dbm.c

..\lib\idx.obj : ..\lib\idx.c

..\lib\idx.sbr : ..\lib\idx.c

exit.obj : exit.c config.h

exit.sbr : exit.c config.h

..\lib\scandir.obj : ..\lib\scandir.c

..\lib\scandir.sbr : ..\lib\scandir.c

updactiv.obj : updactiv.c config.h expire.h

updactiv.sbr : updactiv.c config.h expire.h

arpatime.obj : arpatime.c config.h expire.h

arpatime.sbr : arpatime.c config.h expire.h

misc.obj : misc.c config.h expire.h

misc.sbr : misc.c config.h expire.h

purgebya.obj : purgebya.c config.h expire.h

purgebya.sbr : purgebya.c config.h expire.h

purgebyh.obj : purgebyh.c config.h expire.h

purgebyh.sbr : purgebyh.c config.h expire.h

..\lib\datetime.obj : ..\lib\datetime.c

..\lib\datetime.sbr : ..\lib\datetime.c

match.obj : match.c

match.sbr : match.c

..\lib\version.obj : ..\lib\version.c

..\lib\version.sbr : ..\lib\version.c


$(PROJ).bsc : $(SBRS)
        $(PWBRMAKE) @<<
$(BRFLAGS) $(SBRS)
<<

$(PROJ).exe : $(DEF_FILE) $(OBJS)
!IF $(DEBUG)
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
!IF $(DEBUG)
        $(ILINK) -a -e "$(LINKER) @$(PROJ).lrf" $@
!ELSE
        $(LINKER) @$(PROJ).lrf
!ENDIF


.c.sbr :
!IF $(DEBUG)
        $(CC) /Zs $(CFLAGS_G) $(CFLAGS_D) /FR$@ $<
!ELSE
        $(CC) /Zs $(CFLAGS_G) $(CFLAGS_R) /FR$@ $<
!ENDIF

.c.obj :
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Fo$@ $<
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Fo$@ $<
!ENDIF


run: $(PROJ).exe
        $(PROJ).exe $(RUNFLAGS)

debug: $(PROJ).exe
        CVP $(CVFLAGS) $(PROJ).exe $(RUNFLAGS)
