/* Sokoban v0.50 */
/* Install Command File */

/* Sokoban (v0.50) */
/* Written by T T K Tse Shum Fat. */
/* (C) Copyright Xylodata Limited 1994, 1995. */
/* Xylodata Limited, */
/* 10 Flexford Close, */
/* Chandlers Ford, */
/* Eastleigh, */
/* Hampshire, */
/* SO53 5RZ, */
/* England. */

parse upper arg argument .

es='1b'x'[;3'
re=es'1m'; gr=es'2m'; br=es'3m'; bl=es'4m'; pu=es'5m'; cy=es'6m'; wh=es'7m';

if length(argument) == 1 then
do
   target = argument
end
else
if length(argument) == 2 & right( argument, 1) == ':' then
do
   target = left( argument, 1)
end
else
do
   say
   say 'Usage:' gr'INSTALL' cy'driveletter'wh
   say
   say 'Example:' pu'INSTALL C' wh'to install Sokoban in C:\SK2.'
   say
   say 'The Sk2 folder icon will be created on your desktop.'
   say
   say 'The Sk2s program contains level solutions.'
   say
   exit 0
end

say 'Installing' 'Sokoban' 'v0.50'

parse upper source . . programname .

drive = FILESPEC( 'drive', programname)
path  = FILESPEC( 'path',  programname)
name  = FILESPEC( 'name',  programname)

sourcepath = drive||path
targetpath = target||':\SK2'

null =  '2>nul 1>nul'

'@md' targetpath null

say       'Copying' 'SK2.EXE'
'@copy' sourcepath||'SK2.EXE' targetpath||'\SK2.EXE' null
say       'Copying' 'SK2S.EXE'
'@copy' sourcepath||'SK2S.EXE' targetpath||'\SK2S.EXE' null

say       'Copying' 'SK2HLP.DLL'
'@copy' sourcepath||'SK2HLP.DLL' targetpath||'\SK2HLP.DLL ' null
say       'Copying' 'SK2LVLS.DLL'
'@copy' sourcepath||'SK2LVLS.DLL' targetpath||'\SK2LVLS.DLL' null
say       'Copying' 'SK2SLV.DLL'
'@copy' sourcepath||'SK2SLV.DLL' targetpath||'\SK2SLV.DLL ' null

say       'Copying' 'SK2TEXT.DLL'
'@copy' sourcepath||'SK2TEXT.DLL' targetpath||'\SK2TEXT.DLL' null
say       'Copying' 'SK2READ.EXE'
'@copy' sourcepath||'SK2READ.EXE' targetpath||'\SK2READ.EXE' null

say       'Copying' 'SKORES.EXE'
'@copy' sourcepath||'SKORES.EXE' targetpath||'\SKORES.EXE' null

Sk2Sco = stream( targetpath||'\SK2.SCO', 'C', 'QUERY EXISTS')

if Sk2Sco == '' then   /* new */
do
say       'Copying' 'SK2.SCO'
'@copy' sourcepath||'SK2.SCO' targetpath||'\SK2.SCO' null
end
else  /* already exists, merge scores */
do
say      'Updating' 'SK2.SCO'
'@'sourcepath'SKOMERGE.EXE' targetpath||'\SK2.SCO' sourcepath||'SK2.SCO' null
end

say       'Copying' 'SK2.1'
'@copy' sourcepath||'SK2.1' targetpath||'\SK2.1' null
say       'Copying' 'SK2.2'
'@copy' sourcepath||'SK2.2' targetpath||'\SK2.2' null

call RxFuncAdd 'SysCreateObject', 'RexxUtil', 'SysCreateObject'
call RxFuncAdd 'SysDestroyObject', 'RexxUtil', 'SysDestroyObject'

say 'Creating' 'Desktop' 'folder'

title = 'Sokoban'
classname = 'WPFolder'
location = '<WP_DESKTOP>'
setup = 'OBJECTID=<SK2_Folder>;OPEN=DEFAULT'
call SysCreateObject classname,title,location,setup,'fail'

say 'Creating' 'Folder' 'icons'

title = 'Sk2'
classname = 'WPProgram'
location = '<SK2_Folder>'
setup = 'EXENAME='targetpath'\SK2.EXE;STARTUPDIR='targetpath';PARAMETERS=%'
call SysCreateObject classname,title,location,setup,'update'

title = 'Sk2s'
classname = 'WPProgram'
location = '<SK2_Folder>'
setup = 'EXENAME='targetpath'\SK2S.EXE;STARTUPDIR='targetpath';PARAMETERS=%'
call SysCreateObject classname,title,location,setup,'update'

title = 'ReadMe.Txt'
classname = 'WPProgram'
location = '<SK2_Folder>'
setup = 'EXENAME='targetpath'\SK2READ.EXE;STARTUPDIR='targetpath';PARAMETERS=%'
call SysCreateObject classname,title,location,setup,'update'

call RxFuncDrop 'SysDestroyObject'
call RxFuncDrop 'SysCreateObject'

say 'Done.'

exit 0

